/* mkchain.h */
/* Norbert Doerry
   May 2017 

*/

#define PRINT_VAL  0
#define PRINT_SER  1
#define PRINT_NAME 2

#define DEFAULT_NBR_YEARS 50
#define DEFAULT_NBR_CHAINS 10

#define DEFAULT_MAX_ERROR 0.000001
#define DEFAULT_MAX_ITERATION 100

#define VERSION "1.0"

typedef struct mkchain
{
 int nbr_states;
 int init_year;
 int nbr_years;
 int nbr_chains;
 char *outfilename;
 FILE *out; 
 char *xmlfilename;
 FILE *in;
 char **state_name;  /* index is SER */
 double *val;  /* index is SER */
 double *initial_probability;  /* index is SER */
 double **transition_probability;  /* from - to */
 int **mkchain;  /* chain nbr first,  year second */

 int print_header;  /* = 0 for no  != 0 for yes */
 int print_flag;    /* = PRINT_VAL for val array, PRINT_SER for serial, PRINT_NAME */

 double *steady_state_probability; /* index is SER */
 int calc_flag;  /* = 0 for no != 0 for yes   for calculationg steady state probability vector */
 int max_iteration;   /* maximum number of iterations for calculating steady state probability vector */
 double max_error;  /* maximum RMS error for calcuing stead state probablity vector */
 int actual_iteration;   /* actual number of iterations to converge or max_iteration if did not */
 double actual_error;    /* actual error */

 int debug;

 XMLENTITY *xml;   /* need to include xml.h before this file */
}
MKCHAIN;


